Index: device.c
===================================================================
--- device.c	(revision 0)
+++ device.c	(revision 0)
@@ -0,0 +1,984 @@
+/*
+ * QEMU Device and configuration managament
+ *
+ * Copyright (c) 2008 Fabrice Bellard
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+#include "hw/hw.h"
+#include "console.h"
+
+typedef union {
+    int64_t i;
+    char *str;
+} QEMUFieldValue;
+
+struct QEMUDeviceClassField {
+    QEMUTypeEnum type;
+    char *name;
+    struct QEMUDeviceClassField *next_field;
+};
+
+typedef struct QEMUDeviceClassInitField {
+    QEMUDeviceClassField *field;
+    struct QEMUDeviceClassInitField *next_init_field;
+    QEMUFieldValue u;
+} QEMUDeviceClassInitField;
+
+typedef struct QEMUDeviceField {
+    struct QEMUDeviceField *next_field;
+    QEMUDeviceClassField *field;
+    QEMUFieldValue u;
+} QEMUDeviceField;
+
+static QEMUDeviceClassField *qemu_class_find_field(QEMUDeviceClass *dc,
+                                                   const char *name);
+
+static QEMUDeviceClass *qemu_first_class;
+QEMUDevice *qemu_first_device;
+
+QEMUDeviceClass *qemu_class_new(const char *name, int flags,
+                                const char *descr)
+{
+    QEMUDeviceClass *dc, **pdc;
+    dc = qemu_mallocz(sizeof(QEMUDeviceClass));
+    if (!dc)
+        return NULL;
+    dc->name = qemu_strdup(name);
+    if (descr)
+        dc->descr = qemu_strdup(descr);
+    dc->flags = flags;
+    pdc = &qemu_first_class;
+    while (*pdc != NULL)
+        pdc = &(*pdc)->next_class;
+    *pdc = dc;
+    return dc;
+}
+
+int qemu_class_add_parent(QEMUDeviceClass *dc, 
+                          QEMUDeviceClass *parent)
+{
+    if (dc->nb_parents >= QEMU_CLASS_MAX_PARENTS)
+        return -1;
+    dc->parents[dc->nb_parents++] = parent;
+    return 0;
+}
+
+QEMUDeviceClassField *qemu_class_field_new(QEMUDeviceClass *dc, 
+                                           const char *name,
+                                           QEMUTypeEnum type)
+{
+    QEMUDeviceClassField *dcf, **pdcf;
+    int i;
+
+    /* No duplicate field overriding */
+    for(i = 0; i < dc->nb_parents; i++) {
+        dcf = qemu_class_find_field(dc->parents[i], name);
+        if (dcf)
+            return NULL;
+    }
+
+    dcf = qemu_mallocz(sizeof(QEMUDeviceClassField));
+    if (!dcf)
+        return NULL;
+    dcf->name = qemu_strdup(name);
+    dcf->type = type;
+    pdcf = &dc->first_field;
+    while (*pdcf != NULL)
+        pdcf = &(*pdcf)->next_field;
+    *pdcf = dcf;
+    return dcf;
+}
+
+QEMUDeviceClass *qemu_class_find(const char *name)
+{
+    QEMUDeviceClass *dc;
+    for(dc = qemu_first_class; dc != NULL; dc = dc->next_class) {
+        if (!strcmp(dc->name, name))
+            return dc;
+    }
+    return NULL;
+}
+
+/* return true if dc1 = dc2 or if dc2 is a parent of dc1 */
+int qemu_class_instanceof(QEMUDeviceClass *dc1, QEMUDeviceClass *dc2)
+{
+    int i, ret;
+
+    if (dc1 == dc2)
+        return 1;
+    for(i = 0; i < dc1->nb_parents; i++) {
+        ret = qemu_class_instanceof(dc1->parents[i], dc2);
+        if (ret)
+            return ret;
+    }
+    return 0;
+}
+
+static QEMUDeviceClassField *qemu_class_find_field(QEMUDeviceClass *dc,
+                                                   const char *name)
+{
+    QEMUDeviceClassField *dcf;
+    int i;
+
+    /* look first in class fields */
+    for(dcf = dc->first_field; dcf != NULL; dcf = dcf->next_field) {
+        if (!strcmp(dcf->name, name))
+            return dcf;
+    }
+    
+    /* then in parents */
+    for(i = 0; i < dc->nb_parents; i++) {
+        dcf = qemu_class_find_field(dc->parents[i], name);
+        if (dcf)
+            return dcf;
+    }
+    return NULL;
+}
+
+static QEMUDeviceClassInitField *qemu_class_find_default(QEMUDeviceClass *dc,
+                                                         QEMUDeviceClassField *dcf)
+{
+    QEMUDeviceClassInitField *dci;
+    int i;
+
+    for(dci = dc->first_init_field; dci != NULL; dci = dci->next_init_field) {
+        if (dci->field == dcf)
+            return dci;
+    }
+    /* find in parents */
+    for(i = 0; i < dc->nb_parents; i++) {
+        dci = qemu_class_find_default(dc->parents[i], dcf);
+        if (dci)
+            return dci;
+    }
+    return NULL;
+}
+
+/* set default value for a class field */
+static int qemu_class_set_default(QEMUDeviceClass *dc, const char *name,
+                                  QEMUTypeEnum type, QEMUFieldValue val)
+{
+    QEMUDeviceClassField *dcf;
+    QEMUDeviceClassInitField *dci;
+    dcf = qemu_class_find_field(dc, name);
+    if (dcf->type != type)
+        return -EINVAL;
+    for(dci = dc->first_init_field; dci != NULL; dci = dci->next_init_field) {
+        if (dci->field == dcf)
+            break;
+    }
+    if (!dci) {
+        dci = qemu_mallocz(sizeof(QEMUDeviceClassInitField));
+        dci->field = dcf;
+        dci->next_init_field = dc->first_init_field;
+        dc->first_init_field = dci;
+    }
+    if (type == QEMU_CTYPE_STR) {
+        qemu_free(dci->u.str);
+        dci->u.str = qemu_strdup(val.str);
+    } else {
+        dci->u = val;
+    }
+    return 0;
+}
+
+int qemu_class_set_int(QEMUDeviceClass *dc, const char *name,
+                       int64_t val)
+{
+    QEMUFieldValue u;
+    u.i = val;
+    return qemu_class_set_default(dc, name, QEMU_CTYPE_INT, u);
+}
+
+int qemu_class_set_bool(QEMUDeviceClass *dc, const char *name,
+                        int val)
+{
+    QEMUFieldValue u;
+    u.i = val;
+    return qemu_class_set_default(dc, name, QEMU_CTYPE_BOOL, u);
+}
+
+int qemu_class_set_str(QEMUDeviceClass *dc, const char *name,
+                       const char *str)
+{
+    QEMUFieldValue u;
+    u.str = (char *)str;
+    return qemu_class_set_default(dc, name, QEMU_CTYPE_STR, u);
+}
+
+QEMUDevice *qemu_device_find(const char *name)
+{
+    QEMUDevice *dev;
+    for(dev = qemu_first_device; dev != NULL; dev = dev->dev_next) {
+        if (!strcmp(name, dev->name))
+            return dev;
+    }
+    return NULL;
+}
+
+static QEMUDevice *qemu_device_new1(QEMUDeviceClass *dc, const char *name)
+{
+    QEMUDevice *dev;
+
+    dev = qemu_device_find(name);
+    if (dev)
+        return NULL;
+    dev = qemu_mallocz(sizeof(QEMUDevice));
+    if (!dev)
+        return NULL;
+    dev->name = strdup(name);
+    dev->dev_class = dc;
+    return dev;
+}
+
+QEMUDevice *qemu_device_new(QEMUDeviceClass *dc, const char *name)
+{
+    QEMUDevice *dev, **pdev;
+    dev = qemu_device_new1(dc, name);
+    if (!dev)
+        return NULL;
+    pdev = &qemu_first_device;
+    while (*pdev != NULL)
+        pdev = &(*pdev)->dev_next;
+    *pdev = dev;
+    return dev;
+}
+
+/* insert the device after dev1 */
+QEMUDevice *qemu_device_new_after(QEMUDeviceClass *dc, const char *name,
+                                  QEMUDevice *dev1)
+{
+    QEMUDevice *dev;
+    dev = qemu_device_new1(dc, name);
+    if (!dev)
+        return NULL;
+    dev->dev_next = dev1->dev_next;
+    dev1->dev_next = dev;
+    return dev;
+}
+
+/* same as qemu_device_new, but add a number to ensure the device name
+   is new */
+QEMUDevice *qemu_device_new_nodup(QEMUDeviceClass *dc, const char *base_name)
+{
+    char buf[1024];
+    int i;
+
+    i = 0;
+    for(;;) {
+        snprintf(buf, sizeof(buf), "%s%d", base_name, i);
+        if (!qemu_device_find(buf))
+            break;
+        i++;
+    }
+    return qemu_device_new(dc, buf);
+}
+
+void qemu_device_delete(QEMUDevice *dev)
+{
+    QEMUDevice **pdev;
+    QEMUDeviceField *df, *df_next;
+
+    pdev = &qemu_first_device;
+    while (*pdev != NULL && *pdev != dev) {
+        pdev = &(*pdev)->dev_next;
+    }
+    if (*pdev == NULL)
+        return;
+    *pdev = dev->dev_next;
+
+    for(df = dev->first_field; df != NULL; df = df_next) {
+        df_next = df->next_field;
+        if (df->field->type == QEMU_CTYPE_STR)
+            qemu_free(df->u.str);
+        qemu_free(df);
+    }
+
+    qemu_free(dev->name);
+    qemu_free(dev);
+}
+
+static int qemu_device_set_field(QEMUDevice *dev, const char *name,
+                                 QEMUTypeEnum type, QEMUFieldValue val)
+{
+    QEMUDeviceField *df, **pdf;
+    QEMUDeviceClassField *dcf;
+
+    dcf = qemu_class_find_field(dev->dev_class, name);
+    if (!dcf)
+        return -ENOENT;
+    if (dcf->type != type)
+        return -EINVAL;
+    
+    for(df = dev->first_field; df != NULL; df = df->next_field) {
+        if (df->field == dcf)
+            break;
+    }
+    if (!df) {
+        df = qemu_mallocz(sizeof(QEMUDeviceField));
+        if (!df)
+            return -ENOMEM;
+        df->field = dcf;
+        pdf = &dev->first_field;
+        while (*pdf != NULL)
+            pdf = &(*pdf)->next_field;
+        *pdf = df;
+    }
+    if (type == QEMU_CTYPE_STR) {
+        qemu_free(df->u.str);
+        df->u.str = qemu_strdup(val.str);
+    } else {
+        df->u = val;
+    }
+    return 0;
+}
+
+int qemu_device_set_int(QEMUDevice *dev, const char *name, int64_t val)
+{
+    QEMUFieldValue u;
+    u.i = val;
+    return qemu_device_set_field(dev, name, QEMU_CTYPE_INT, u);
+}
+                        
+int qemu_device_set_bool(QEMUDevice *dev, const char *name, int val)
+{
+    QEMUFieldValue u;
+    u.i = (val != 0);
+    return qemu_device_set_field(dev, name, QEMU_CTYPE_BOOL, u);
+}
+
+int qemu_device_set_str(QEMUDevice *dev, const char *name, const char *str)
+{
+    QEMUFieldValue u;
+    u.str = (char *)str;
+    return qemu_device_set_field(dev, name, QEMU_CTYPE_STR, u);
+}
+
+/* Note: if there is an error, a zero (or empty string) is returned */
+static int qemu_device_get_field(QEMUDevice *dev, 
+                                 const char *name,
+                                 QEMUTypeEnum type,
+                                 QEMUFieldValue *pu)
+{
+    QEMUDeviceField *df;
+    QEMUDeviceClassField *dcf;
+    QEMUDeviceClassInitField *dci;
+    int ret;
+
+    dcf = qemu_class_find_field(dev->dev_class, name);
+    if (!dcf) {
+        ret = -ENOENT;
+        /* for debug */
+        fprintf(stderr, "%s: unknown field '%s'\n", dev->name, name);
+        goto fail;
+    }
+    if (dcf->type != type) {
+        fprintf(stderr, "%s: bad type for field '%s'\n", dev->name, name);
+        ret = -EINVAL;
+        goto fail;
+    }
+
+    /* is there a field ? */
+    for(df = dev->first_field; df != NULL; df = df->next_field) {
+        if (df->field == dcf) {
+            *pu = df->u;
+            return 0;
+        }
+    }
+    
+    dci = qemu_class_find_default(dev->dev_class, dcf);
+    if (dci) {
+        *pu = dci->u;
+        return 0;
+    }
+    ret = 0;
+ fail:
+    switch(type) {
+    case QEMU_CTYPE_INT:
+    case QEMU_CTYPE_BOOL:
+        pu->i = 0;
+        break;
+    case QEMU_CTYPE_STR:
+        pu->str = (char *)"";
+        break;
+    }
+    return ret;
+}
+
+int64_t qemu_device_get_int(QEMUDevice *dev, const char *name)
+{
+    QEMUFieldValue u;
+    qemu_device_get_field(dev, name, QEMU_CTYPE_INT, &u);
+    return u.i;
+}
+
+int qemu_device_get_bool(QEMUDevice *dev, const char *name)
+{
+    QEMUFieldValue u;
+    qemu_device_get_field(dev, name, QEMU_CTYPE_BOOL, &u);
+    return u.i;
+}
+
+/* Note: NULL is never returned */
+const char *qemu_device_get_str(QEMUDevice *dev, const char *name)
+{
+    QEMUFieldValue u;
+    qemu_device_get_field(dev, name, QEMU_CTYPE_STR, &u);
+    return u.str;
+}
+
+static void __attribute__((format(printf, 3, 4))) parse_error(const char *filename, int line_num,
+                        const char *fmt, ...)
+{
+    va_list ap;
+    va_start(ap, fmt);
+    fprintf(stderr, "%s:%d: ", filename, line_num);
+    vfprintf(stderr, fmt, ap);
+    fprintf(stderr, "\n");
+    va_end(ap);
+}
+
+static inline int is_first_ident(int c)
+{
+    return (c >= 'a' && c <= 'z') ||
+        (c >= 'A' && c <= 'Z') ||
+        (c == '_');
+}
+
+static inline int is_next_ident(int c)
+{
+    return (c >= 'a' && c <= 'z') ||
+        (c >= 'A' && c <= 'Z') ||
+        (c >= '0' && c <= '9') ||
+        (c == '_');
+}
+
+const char *ctype_str[3] = {
+    "string",
+    "bool",
+    "int",
+};
+
+void dump_value(QEMUTypeEnum type, QEMUFieldValue u)
+{
+    switch(type) {
+    case QEMU_CTYPE_STR:
+        printf("\"%s\"", u.str);
+        break;
+    case QEMU_CTYPE_INT:
+        printf("%" PRId64, u.i);
+        break;
+    case QEMU_CTYPE_BOOL:
+        if (u.i)
+            printf("true");
+        else
+            printf("false");
+        break;
+    default:
+        break;
+    }
+}
+
+void dump_classes(void)
+{
+    QEMUDeviceClass *dc;
+    QEMUDeviceClassField *dcf;
+    QEMUDeviceClassInitField *dci;
+    int i;
+
+    for(dc = qemu_first_class; dc != NULL; dc = dc->next_class) {
+        printf("Class %s", dc->name);
+        if (dc->nb_parents > 0) {
+            printf(": ");
+            for(i = 0; i < dc->nb_parents; i++) {
+                if (i != 0)
+                    printf(", ");
+                printf("%s", dc->parents[i]->name);
+            }
+        }
+        if (dc->flags & QEMU_CLASS_ABSTRACT)
+            printf(" [abstract]");
+        if (dc->descr) {
+            printf(" {%s}", dc->descr);
+        }
+        printf("\n");
+        for(dcf = dc->first_field; dcf != NULL; dcf = dcf->next_field) {
+            printf("  %s: %s\n", dcf->name, ctype_str[dcf->type]);
+        }
+        
+        if (dc->first_init_field) {
+            printf("\n  Defaults:\n");
+            for(dci = dc->first_init_field; dci != NULL; dci = dci->next_init_field) {
+                printf("    %s = ", dci->field->name);
+                dump_value(dci->field->type, dci->u);
+                printf("\n");
+            }
+        }
+
+        printf("\n");
+    }
+}
+
+void dump_devices(void)
+{
+    QEMUDevice *dev;
+    QEMUDeviceField *df;
+
+    for(dev = qemu_first_device; dev != NULL; dev = dev->dev_next) {
+        printf("%s.type = \"%s\"\n", dev->name, dev->dev_class->name);
+        for(df = dev->first_field; df != NULL; df = df->next_field) {
+            printf("%s.%s = ", dev->name, df->field->name);
+            dump_value(df->field->type, df->u);
+            printf("\n");
+        }
+        printf("\n");
+    }
+}
+
+int qemu_parse_config(QEMUDevice **pmain_dev, const char *filename, int flags)
+{
+    QEMUFile *f;
+    char line[1024];
+    const char *p;
+    char obj_name[128], *q, field_name[128], buf[1024];
+    int line_num;
+    QEMUTypeEnum type;
+    QEMUFieldValue u;
+
+    f = qemu_fopen(filename, "rb");
+    if (!f) {
+        if (flags & QEMU_CONF_ERR_FILE)
+            perror(filename);
+        return -2;
+    }
+    line_num = 0;
+    for(;;) {
+        line_num++;
+        if (qemu_get_line(f, line, sizeof(line)) < 0)
+            break;
+        p = line;
+        while (isspace(*(uint8_t *)p))
+            p++;
+        if (*p == '#')
+            continue;
+        if (*p == '\0')
+            continue;
+
+        if (!is_first_ident(*(uint8_t *)p)) {
+            parse_error(filename, line_num, "object or field name expected");
+            goto fail;
+        }
+        q = obj_name;
+        while (is_next_ident(*(uint8_t *)p)) {
+            if ((q - obj_name) < sizeof(obj_name) - 1)
+                *q++ = *p;
+            p++;
+        }
+        *q = '\0';
+
+        while (isspace(*(uint8_t *)p))
+            p++;
+
+        if (*p == '.') {
+            p++;
+            while (isspace(*(uint8_t *)p))
+                p++;
+            if (!is_first_ident(*(uint8_t *)p)) {
+                parse_error(filename, line_num, "field name expected");
+                goto fail;
+            }
+            q = field_name;
+            while (is_next_ident(*(uint8_t *)p)) {
+                if ((q - field_name) < sizeof(field_name) - 1)
+                    *q++ = *p;
+                p++;
+            }
+            *q = '\0';
+        } else {
+            pstrcpy(field_name, sizeof(field_name), obj_name);
+            obj_name[0] = '\0';
+        }
+        
+        while (isspace(*(uint8_t *)p))
+            p++;
+        if (*p != '=') {
+            parse_error(filename, line_num, "'=' expected");
+            goto fail;
+        }
+        p++;
+        while (isspace(*(uint8_t *)p))
+            p++;
+        
+        if (*p == '"') {
+            p++;
+            q = buf;
+            for(;;) {
+                if (*p == '\0') {
+                    parse_error(filename, line_num, "'\"' expected");
+                    goto fail;
+                } else if (*p == '"') {
+                    p++;
+                    break;
+                } else if (*p == '\\') {
+                    p++;
+                    switch(*(uint8_t *)p) {
+                    case '\"':
+                    case '\'':
+                    case '\\':
+                        *q++ = *p++;
+                        break;
+                    case 'r':
+                        *q++ = '\r';
+                        p++;
+                        break;
+                    case 'n':
+                        *q++ = '\n';
+                        p++;
+                        break;
+                    case 't':
+                        *q++ = '\t';
+                        p++;
+                        break;
+                    case '0' ... '7':
+                        {
+                            int v, i, c;
+                            v = 0;
+                            for(i=0;i<3;i++) {
+                                c = *(uint8_t *)p;
+                                if (c >= '0' && c <= '7')
+                                    v = v * 8 + c - '0';
+                                else
+                                    break;
+                                p++;
+                            }
+                            *q++ = v;
+                        }
+                        break;
+                        /* XXX: add 'x' quoted with UTF8 encoding */
+                    default:
+                        parse_error(filename, line_num, "invalid backquoted character");
+                        goto fail;
+                    }
+                } else {
+                    *q++ = *p++;
+                }
+            }
+            *q = '\0';
+            type = QEMU_CTYPE_STR;
+            u.str = buf;
+        } else if (isdigit(*(uint8_t *)p)) {
+            u.i = strtoll(p, (char **)&p, 0);
+            type = QEMU_CTYPE_INT;
+        } else {
+            q = buf;
+            while (*p != '\0' && !isspace(*(uint8_t *)p)) {
+                *q++ = *p++;
+            }
+            *q = '\0';
+            if (!strcmp(buf, "true")) {
+                u.i = 1;
+                type = QEMU_CTYPE_BOOL;
+            } else if (!strcmp(buf, "false")) {
+                u.i = 0;
+                type = QEMU_CTYPE_BOOL;
+            } else {
+                parse_error(filename, line_num, "invalid value");
+                goto fail;
+            }
+        }
+        while (isspace(*(uint8_t *)p))
+            p++;
+        if (*p != '\0' && *p != '#') {
+            parse_error(filename, line_num, "unexpected chars at end of line");
+            goto fail;
+        }
+#if 0
+        {
+            printf("obj=%s field=%s val=", obj_name, field_name);
+            dump_value(type, u);
+            printf("\n");
+        }
+#endif
+        if (!strcmp(field_name, "type")) {
+            QEMUDeviceClass *dc;
+            QEMUDevice *dev;
+
+            if (flags & QEMU_CONF_NO_OBJ) {
+                parse_error(filename, line_num, "new object instantiation not allowed here");
+                goto fail;
+            }
+            /* type field means instance creation */
+            if (type != QEMU_CTYPE_STR) {
+                parse_error(filename, line_num, "string value expected");
+                goto fail;
+            }
+            dc = qemu_class_find(u.str);
+            if (!dc) {
+                parse_error(filename, line_num, "type '%s' does not exist",
+                            u.str);
+                goto fail;
+            }
+            if (dc->flags & QEMU_CLASS_ABSTRACT) {
+                parse_error(filename, line_num, "abstract classes cannot be instantiated");
+                goto fail;
+            }
+
+            if (obj_name[0] == '\0') {
+                /* In order to allow a machine type change from the
+                   command line, we allow a type change for the main
+                   object. The previous object is destroyed. */
+                if (dc != (*pmain_dev)->dev_class) {
+                    char name[128];
+                    pstrcpy(name, sizeof(name), (*pmain_dev)->name);
+                    qemu_device_delete(*pmain_dev);
+                    *pmain_dev = qemu_device_new(dc, name);
+                }
+            } else {
+                dev = qemu_device_new(dc, obj_name);
+                if (!dev) {
+                    parse_error(filename, line_num, "object '%s' already exists",
+                                obj_name);
+                    goto fail;
+                }
+            }
+        } else {
+            QEMUDevice *dev;
+            QEMUDeviceClassField *dcf;
+            int ret;
+
+            if (obj_name[0] == '\0') {
+                dev = *pmain_dev;
+            } else {
+                dev = qemu_device_find(obj_name);
+            }
+            if (!dev) {
+                parse_error(filename, line_num, "object '%s' is not defined",
+                            obj_name);
+                goto fail;
+            }
+            dcf = qemu_class_find_field(dev->dev_class, field_name);
+            if (dcf && 
+                dcf->type == QEMU_CTYPE_BOOL && 
+                type == QEMU_CTYPE_INT) {
+                /* convert int to bool */
+                if (u.i != 0 && u.i != 1) {
+                    parse_error(filename, line_num, "boolean value expected");
+                    goto fail;
+                }
+                type = QEMU_CTYPE_BOOL;
+            }
+            switch(type) {
+            case QEMU_CTYPE_INT:
+                ret = qemu_device_set_int(dev, field_name, u.i);
+                break;
+            case QEMU_CTYPE_BOOL:
+                ret = qemu_device_set_bool(dev, field_name, u.i);
+                break;
+            case QEMU_CTYPE_STR:
+                ret = qemu_device_set_str(dev, field_name, u.str);
+                break;
+            default:
+                abort();
+            }
+            if (ret < 0) {
+                if (ret == -ENOENT) {
+                    parse_error(filename, line_num, "field '%s' does not exist",
+                                field_name);
+                    goto fail;
+                } else {
+                    parse_error(filename, line_num, "invalid type for field '%s'",
+                                field_name);
+                    goto fail;
+                }
+            }
+        }
+    }
+
+    qemu_fclose(f);
+    return 0;
+ fail:
+    qemu_fclose(f);
+    return -1;
+}
+
+/* compatibility: add device fields from param list. trans_list allows
+   to change the name of a field or to ignore it. */
+int qemu_device_set_params(QEMUDevice *dev, const char *opts,
+                           const char *trans_list)
+{
+    char opt_name[128], alt_opt_name[128], opt_value[1024];
+    QEMUFieldValue u;
+    const char *p;
+    QEMUDeviceClassField *dcf;
+
+    p = opts;
+    if (*p == '\0')
+        return 0;
+    for(;;) {
+        p = get_opt_name(opt_name, sizeof(opt_name), p);
+        if (*p != '=')
+            return -1;
+        p++;
+        p = get_opt_value(opt_value, sizeof(opt_value), p);
+        
+        if (get_param_value(alt_opt_name, sizeof(alt_opt_name), opt_name, 
+                            trans_list) > 0) {
+            pstrcpy(opt_name, sizeof(opt_name), alt_opt_name);
+        }
+        if (strcmp(opt_name, "!") != 0) {
+            dcf = qemu_class_find_field(dev->dev_class, opt_name);
+            if (!dcf) {
+                fprintf(stderr, "Unknown field: '%s'\n", opt_name);
+                return -1;
+            }
+            switch(dcf->type) {
+            case QEMU_CTYPE_INT:
+                u.i = strtoll(opt_value, NULL, 0);
+                break;
+            case QEMU_CTYPE_BOOL:
+                if (!strcmp(opt_value, "1") ||
+                    !strcmp(opt_value, "on") ||
+                    !strcmp(opt_value, "true")) {
+                    u.i = 1;
+                } else if (!strcmp(opt_value, "0") ||
+                    !strcmp(opt_value, "off") ||
+                    !strcmp(opt_value, "false")) {
+                    u.i = 0;
+                } else {
+                    fprintf(stderr, "invalid boolean value for field '%s'\n",
+                            opt_name);
+                    return -1;
+                }
+                break;
+            case QEMU_CTYPE_STR:
+                u.str = opt_value;
+                break;
+            default:
+                return -1;
+            }
+            if (qemu_device_set_field(dev, opt_name, dcf->type, u) != 0)
+                return -1;
+        }
+        if (*p != ',')
+            break;
+        p++;
+    }
+    return 0;
+}
+
+
+void do_info_devices(void)
+{
+    QEMUDevice *dev;
+
+    term_printf("%-12s %-12s %s\n", "DEVICE", "TYPE", "DESCRIPTION");
+    for(dev = qemu_first_device; dev != NULL; dev = dev->dev_next) {
+        if (dev == qemu_prefs)
+            continue;
+        term_printf("%-12s %-12s %s\n", 
+               dev->name, 
+               dev->dev_class->name, 
+               dev->dev_class->descr);
+    }
+}
+
+static void term_dump_value(QEMUTypeEnum type, QEMUFieldValue u)
+{
+    switch(type) {
+    case QEMU_CTYPE_STR:
+        term_printf("\"%s\"", u.str);
+        break;
+    case QEMU_CTYPE_INT:
+        term_printf("%" PRId64, u.i);
+        break;
+    case QEMU_CTYPE_BOOL:
+        if (u.i)
+            term_printf("true");
+        else
+            term_printf("false");
+        break;
+    default:
+        break;
+    }
+}
+
+void do_info_classes(const char *class_name)
+{
+    QEMUDeviceClass *dc, *dc1;
+
+    if (class_name) {
+        QEMUDeviceClassField *dcf;
+        QEMUDeviceClassInitField *dci;
+        int i;
+
+        dc = qemu_class_find(class_name);
+        if (!dc) {
+            term_printf("unknown device class: '%s'\n", class_name);
+            return;
+        }
+        term_printf("Parents: ");
+        for(i=0;i<dc->nb_parents;i++) {
+            if (i != 0)
+                term_printf(", ");
+            term_printf("%s", dc->parents[i]->name);
+        }
+        term_printf("\n");
+
+        term_printf("Fields:\n");
+        for(dcf = dc->first_field; dcf != NULL; dcf = dcf->next_field) {
+            term_printf("  %s: %s\n", dcf->name, ctype_str[dcf->type]);
+        }
+        
+        if (dc->first_init_field) {
+            term_printf("Defaults:\n");
+            for(dci = dc->first_init_field; dci != NULL; dci = dci->next_init_field) {
+                term_printf("  %s = ", dci->field->name);
+                term_dump_value(dci->field->type, dci->u);
+                term_printf("\n");
+            }
+        }
+    } else {
+        QEMUDeviceClass *dc1;
+        int i;
+
+        dc1 = qemu_class_find("preferences");
+        term_printf("%-20s %s\n", "CLASS", "DESCRIPTION {PARENTS}");
+        for(dc = qemu_first_class; dc != NULL; dc = dc->next_class) {
+            if (dc->flags & QEMU_CLASS_ABSTRACT)
+                continue;
+            if (dc == dc1)
+                continue;
+            term_printf("%-20s", dc->name);
+            if (dc->descr)
+                term_printf(" %s", dc->descr);
+            if (dc->nb_parents) {
+                term_printf(" {");
+                for(i=0;i<dc->nb_parents;i++) {
+                    if (i != 0)
+                        term_printf(", ");
+                    term_printf("%s", dc->parents[i]->name);
+                }
+                term_printf("}");
+            }
+            term_printf("\n");
+        }
+    }
+}
+
